import React__default, { useState, createElement, Fragment } from 'react';
import { applyMiddleware, createStore as createStore$1 } from 'redux';
export * from 'redux';
import { persistCombineReducers, persistStore } from 'redux-persist';
export * from 'redux-persist';
export { PersistGate } from 'redux-persist/integration/react';
import storage from 'redux-persist/lib/storage';

var styles = {"animation-wrap":"_1I3OZ","pulse":"_2_Mn3"};

function Transition(_ref) {
  var children = _ref.children,
      _ref$duration = _ref.duration,
      duration = _ref$duration === void 0 ? 0.2 : _ref$duration,
      _ref$animation = _ref.animation,
      animation = _ref$animation === void 0 ? 'pulse' : _ref$animation,
      _ref$onPress = _ref.onPress,
      onPress = _ref$onPress === void 0 ? function () {} : _ref$onPress,
      _ref$enable = _ref.enable,
      enable = _ref$enable === void 0 ? true : _ref$enable,
      _ref$effectFirst = _ref.effectFirst,
      effectFirst = _ref$effectFirst === void 0 ? true : _ref$effectFirst;

  var _useState = useState(''),
      animationName = _useState[0],
      setAnimationName = _useState[1];

  var handleClick = function handleClick(e) {
    if (enable) {
      e.preventDefault();
      setAnimationName(animation);
      !effectFirst && onPress();
      setTimeout(function () {
        setAnimationName('');
        effectFirst && onPress();
      }, duration * 1000);
    }
  };

  return /*#__PURE__*/React__default.createElement("div", {
    className: styles['animation-wrap'],
    style: {
      animationDuration: duration + "s",
      animationName: styles[animationName],
      transformOrigin: '50% 50% 0'
    },
    onClick: function onClick(e) {
      return handleClick(e);
    }
  }, children);
}

var Transition$1 = React__default.memo(Transition);

var styles$1 = {"btn-wrap-level-1":"_2tVV0","active":"_2-mkg","disable":"_2rCHA","btn-wrap-level-2":"_2CtHt"};

function Button(_ref) {
  var children = _ref.children,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? '118px' : _ref$width,
      _ref$status = _ref.status,
      status = _ref$status === void 0 ? '' : _ref$status,
      _ref$level = _ref.level,
      level = _ref$level === void 0 ? 1 : _ref$level,
      _ref$onPress = _ref.onPress,
      onPress = _ref$onPress === void 0 ? function () {} : _ref$onPress;
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$1["btn-wrap-level-" + level] + " " + (status ? styles$1[status] : ''),
    style: {
      width: width
    },
    onClick: status !== 'disable' ? onPress : function () {}
  }, children);
}

var Button$1 = React__default.memo(Button);

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var styles$2 = {"wraper-progress":"_1a-5O","circle":"_3s6J0","left":"_Z2lVJ","right":"_1kAL_","content":"_2dS-l","star":"_h49gn","level-bg-1":"_2Yb45","level-bg-2":"_bWiBM","level-bg-3":"_387wH","level-bg-4":"_20vig","level-bg-5":"_20Cp6","level-border-0":"_2g1Wx","level-border-1":"_3ZMju","level-border-2":"_2vKUN","level-border-3":"_3aDY-","level-border-4":"_1IDF2","level-border-5":"_1jRMq","level-border-6":"_3QIs1"};

var _path;

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$1.apply(this, arguments);
}

function SvgIconStar(props) {
  return /*#__PURE__*/createElement("svg", _extends$1({
    xmlns: "http://www.w3.org/2000/svg",
    width: 22.466,
    height: 21.529
  }, props), _path || (_path = /*#__PURE__*/createElement("path", {
    d: "M11.233 17.5l5.075 3.069a1.22 1.22 0 001.818-1.32l-1.342-5.771 4.488-3.889a1.22 1.22 0 00-.7-2.14l-5.906-.5-2.308-5.456a1.223 1.223 0 00-2.25 0L7.796 6.935l-5.906.5a1.22 1.22 0 00-.7 2.14l4.488 3.889-1.342 5.772a1.22 1.22 0 001.822 1.321z",
    fill: "#dfdfdf",
    stroke: "#fff",
    strokeWidth: 1.5
  })));
}

var _path$1;

function _extends$2() {
  _extends$2 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$2.apply(this, arguments);
}

function SvgIconStarFinish(props) {
  return /*#__PURE__*/createElement("svg", _extends$2({
    xmlns: "http://www.w3.org/2000/svg",
    width: 22.466,
    height: 21.529
  }, props), _path$1 || (_path$1 = /*#__PURE__*/createElement("path", {
    d: "M11.233 17.5l5.075 3.069a1.22 1.22 0 001.818-1.32l-1.342-5.771 4.488-3.889a1.22 1.22 0 00-.7-2.14l-5.906-.5-2.308-5.456a1.223 1.223 0 00-2.25 0L7.796 6.935l-5.906.5a1.22 1.22 0 00-.7 2.14l4.488 3.889-1.342 5.772a1.22 1.22 0 001.822 1.321z",
    fill: "#ffcb05",
    stroke: "#fff",
    strokeWidth: 1.5
  })));
}

function CircleProgress(_ref) {
  var _ref$percent = _ref.percent,
      percent = _ref$percent === void 0 ? 30 : _ref$percent,
      _ref$level = _ref.level,
      level = _ref$level === void 0 ? 1 : _ref$level,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? '64px' : _ref$width,
      _ref$img = _ref.img,
      img = _ref$img === void 0 ? '' : _ref$img,
      _ref$imgWidth = _ref.imgWidth,
      imgWidth = _ref$imgWidth === void 0 ? '32px' : _ref$imgWidth,
      _ref$borderWidth = _ref.borderWidth,
      borderWidth = _ref$borderWidth === void 0 ? '4px' : _ref$borderWidth,
      _ref$isShowStar = _ref.isShowStar,
      isShowStar = _ref$isShowStar === void 0 ? false : _ref$isShowStar;
  var style = {
    width: width,
    height: width
  };
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$2['wraper-progress'],
    style: _extends({}, style, {
      borderWidth: borderWidth
    })
  }, /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.circle,
    style: _extends({}, style, {
      margin: "-" + borderWidth + " 0 0 -" + borderWidth
    })
  }, /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.left + " " + styles$2["level-border-" + level],
    style: {
      transform: "rotate(" + (percent >= 50 ? 0 : percent * 3.6 - 180) + "deg)",
      borderWidth: borderWidth
    }
  }), /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.right + " " + styles$2["level-border-" + (percent < 50 ? 0 : level)],
    style: {
      transform: "rotate(" + (percent >= 50 ? percent >= 100 ? 0 : percent * 3.6 : 0) + "deg)",
      borderWidth: borderWidth
    }
  }))), /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.content + " " + styles$2["level-bg-" + level],
    style: {
      width: "calc(" + width + " - 2*" + borderWidth + " - 6px)",
      height: "calc(" + width + " - 2*" + borderWidth + " - 6px)",
      margin: "3px 0 0 3px"
    }
  }, /*#__PURE__*/React__default.createElement("img", {
    alt: "",
    src: img,
    style: {
      width: imgWidth,
      height: imgWidth
    }
  })), isShowStar && /*#__PURE__*/React__default.createElement(Fragment, null, percent >= 100 ? /*#__PURE__*/React__default.createElement(SvgIconStar, {
    className: styles$2.star
  }) : /*#__PURE__*/React__default.createElement(SvgIconStarFinish, {
    className: styles$2.star
  })));
}

var CircleProgress$1 = React__default.memo(CircleProgress);

var STATUS_COMPONENT = {
  LOADING: 'LOADING',
  SUCCESS: 'SUCCESS',
  FAIL: 'FAIL'
};

var styles$3 = {"wraper-loading":"_1QRz-","spinIcon":"_3DPya","wraper-error":"_1FQHd"};

var _path$2;

function _extends$3() {
  _extends$3 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$3.apply(this, arguments);
}

function SvgIconLoading(props) {
  return /*#__PURE__*/createElement("svg", _extends$3({
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 512 512"
  }, props), _path$2 || (_path$2 = /*#__PURE__*/createElement("path", {
    d: "M256 512c-34.6 0-68.1-6.8-99.6-20.1C125.9 479 98.5 460.5 75 437s-42-50.9-54.9-81.4C6.8 324.1 0 290.5 0 256c0-9.9 8.1-18 18-18s18 8.1 18 18c0 29.7 5.8 58.5 17.3 85.6 11.1 26.2 26.9 49.8 47.1 70 20.2 20.2 43.8 36.1 69.9 47.1 27.1 11.5 55.9 17.3 85.6 17.3s58.5-5.8 85.6-17.3c26.2-11.1 49.8-27 70-47.2 20.2-20.2 36.1-43.8 47.1-69.9 11.5-27.1 17.3-55.9 17.3-85.6 0-29.7-5.8-58.5-17.3-85.6-11.1-26.1-27.1-49.9-47.2-70-20-20.1-43.8-36.1-69.9-47.1C314.5 41.8 285.7 36 256 36c-9.9 0-18-8.1-18-18s8.1-18 18-18c34.6 0 68.1 6.8 99.6 20.1C386.2 33 413.5 51.5 437 75s42 50.9 54.9 81.4c13.4 31.5 20.1 65.1 20.1 99.6s-6.8 68.1-20.1 99.6C479 386.1 460.5 413.5 437 437s-50.9 42-81.4 54.9c-31.5 13.4-65 20.1-99.6 20.1z"
  })));
}

function WraperComponent(_ref) {
  var status = _ref.status,
      children = _ref.children,
      _ref$ErrorComponent = _ref.ErrorComponent,
      ErrorComponent = _ref$ErrorComponent === void 0 ? function () {
    return /*#__PURE__*/React__default.createElement(Fragment, null);
  } : _ref$ErrorComponent,
      _ref$height = _ref.height,
      height = _ref$height === void 0 ? '100%' : _ref$height;
  return /*#__PURE__*/React__default.createElement(Fragment, null, status === STATUS_COMPONENT.LOADING && /*#__PURE__*/React__default.createElement("div", {
    className: styles$3['wraper-loading'],
    style: {
      height: height
    }
  }, /*#__PURE__*/React__default.createElement(SvgIconLoading, null)), status === STATUS_COMPONENT.FAIL && /*#__PURE__*/React__default.createElement("div", {
    className: styles$3['wraper-error'],
    style: {
      height: height
    }
  }, /*#__PURE__*/React__default.createElement(ErrorComponent, null)), status === STATUS_COMPONENT.SUCCESS && /*#__PURE__*/React__default.createElement(Fragment, null, children));
}

var WraperComponent$1 = React__default.memo(WraperComponent);

var MiddlewareRegistry = /*#__PURE__*/function () {
  function MiddlewareRegistry() {
    this._elements = [];
    this.register = MiddlewareRegistry.prototype.register;
  }

  var _proto = MiddlewareRegistry.prototype;

  _proto.applyMiddleware = function applyMiddleware$1() {
    if (this._elements.length === 0) {
      return applyMiddleware();
    }

    return applyMiddleware.apply(void 0, this._elements);
  };

  _proto.register = function register(middlewares) {
    this._elements = this._elements.concat(middlewares);
  };

  return MiddlewareRegistry;
}();

var MiddlewareRegistry$1 = new MiddlewareRegistry();

var ReducerRegistry = /*#__PURE__*/function () {
  function ReducerRegistry() {
    this._elements = {};
    this.register = ReducerRegistry.prototype.register;
  }

  var _proto = ReducerRegistry.prototype;

  _proto.combineReducers = function combineReducers(persistConfig) {
    return persistCombineReducers(persistConfig, this._elements);
  };

  _proto.register = function register(name, reducer) {
    this._elements[name] = reducer;
  };

  return ReducerRegistry;
}();

var ReducerRegistry$1 = new ReducerRegistry();

var createStore = function createStore(_ref) {
  var whitelist = _ref.whitelist,
      persistKey = _ref.persistKey;
  var persistConfig = {
    key: persistKey,
    storage: storage,
    whitelist: whitelist
  };
  var reducers = ReducerRegistry$1.combineReducers(persistConfig);
  var middleware = MiddlewareRegistry$1.applyMiddleware();
  var store = createStore$1(reducers, middleware);
  var persistor = persistStore(store, {}, function () {});
  return {
    persistor: persistor,
    store: store
  };
};

export { Button$1 as Button, CircleProgress$1 as CircleProgress, MiddlewareRegistry$1 as MiddlewareRegistry, ReducerRegistry$1 as ReducerRegistry, Transition$1 as Transition, WraperComponent$1 as WraperComponent, createStore };
//# sourceMappingURL=index.modern.js.map
